-- Definitions for all of Bean's shit!

-- AKA; mostly bombs!
-- but first, CONSTANTS!

rawset(_G, "BEAN_THROWCOOLDOWN", TICRATE/2)		-- cooldown for throwing
rawset(_G, "BEAN_BOMBFORCE", 32<<FRACBITS)		-- arbitrary modifer for bomb jump strength
rawset(_G, "BEAN_MAXBOMBS", 2)					-- max # of bombs bean can throw.
rawset(_G, "BEAN_MAXPREDICTTICS", TICRATE*4)	-- max tics of prediction for bomb trajectory

freeslot("MT_BEANBOMB", "SPR_BBOM", "S_BEANBOMB", "S_BEANBOMBDEAD")
freeslot("sfx_bntoss", "sfx_bnboom")

freeslot("S_BEAN_XP1", "S_BEAN_XP2", "S_BEAN_XP3", "S_BEAN_XP4")
-- yes we need states for this shit because for some reason actions are tied to the vanilla variants. :mike:

-- for wait anim:
freeslot("SPR_WBMB")

--spr2 constants for bean + states:
freeslot("SPR2_THRW", "SPR2_LNCH", "SPR2_SLID")
freeslot("S_PLAY_FALLSSTATE", "S_PLAY_BEANTHROW", "S_PLAY_BEANLAUNCH", "S_PLAY_BEANSLIDE")

-- (automatically transitions to S_PLAY_FALL)
states[S_PLAY_BEANTHROW] = 	{SPR_PLAY, SPR2_THRW|FF_SPR2ENDSTATE, 2, nil, S_PLAY_FALLSSTATE, 0, S_PLAY_BEANTHROW}
states[S_PLAY_BEANLAUNCH] = {SPR_PLAY, SPR2_LNCH, 1, nil, 0, 0, S_PLAY_BEANLAUNCH}
states[S_PLAY_BEANSLIDE] =	{SPR_PLAY, SPR2_SLID, 1, nil, 0, 0, S_PLAY_BEANSLIDE}

-- Special action for bean to determine what to transition his throw into.
function A_BeanThrowState(actor)

	if not P_IsObjectOnGround(actor) or not actor.player	-- failsafe.
		actor.state = S_PLAY_FALL
	elseif R_PointToDist2(0, 0, actor.momx, actor.momy) >= FixedMul(actor.scale, actor.player.runspeed)
		actor.state = S_PLAY_RUN
	elseif R_PointToDist2(0, 0, actor.momx, actor.momy) == 0
		actor.state = S_PLAY_STND
	else
		actor.state = S_PLAY_WALK
	end
end
states[S_PLAY_FALLSSTATE] = {SPR_PLAY, SPR2_STND, 1, A_BeanThrowState, 0, 0, S_PLAY_STND}

for i = 0, 3
	states[S_BEAN_XP1+i] = {SPR_BARX, i|FF_FULLBRIGHT, 2, nil, 0, 0, (i < 3 and S_BEAN_XP1+(i+1) or S_NULL)}
end

mobjinfo[MT_BEANBOMB] = {
	doomednum = -1,
	spawnstate = S_BEANBOMB,
	deathstate = S_BEANBOMBDEAD,
	xdeathstate = S_BEANBOMBDEAD,
	spawnhealth = 1000,
	radius = 16 << FRACBITS,
	height = 32 << FRACBITS,
	flags = MF_MISSILE,	-- This will help them die on walls properly so that we don't have to do it ourselves.
}

-- Blockmap search for the bomb:
local function PIT_BombBlockmap(mo, v)
	if not mo or not mo.valid return end
	if not v or not v.valid return end	--!?
	if mo == v return end	-- !>!?!?!??!

	if R_PointToDist2(mo.x, mo.y, v.x, v.y) > 192*mo.scale return end
	if abs(mo.z - v.z) > 192*mo.scale return end

	-- annoying case.
	if v.type == MT_METALSONIC_BATTLE
		local t = P_SpawnMobj(v.x, v.y, v.z, MT_THOK)
		t.state = S_INVISIBLE
		t.flags = MF_NOGRAVITY|MF_MISSILE
		t.fuse = 2
		t.target = mo.target
		-- yes, we can spawn pain on ms' ass.
		return
	end

	if v == mo.target	-- it's me! I threw the bomb!
	and mo.target and mo.target.valid

		/*local curspd = max(12*mo.scale, mo.target.player.speed)
		P_InstaThrust(mo.target, mo.target.angle, curspd*13/10)
		mo.target.momz = mo.target.player.speed/3*/


		/*local finalspeed = spd*3/2 - zdiff
		P_InstaThrust(tp, tp.angle, finalspeed)
		mo.momz = zdiff*2*/

		-- negate < 0 momz before applying bomb knockback.
		-- otherwise the bomb would have to undo our momentum first

		if v.eflags & MFE_VERTICALFLIP
			v.momz = min($, 0)
		else
			v.momz = max($, 0)
		end

		local tp = v

		local dz = v.z - mo.z + ((v.height - mo.height/2)*P_MobjFlip(v))
		local dx = (v.x - mo.x)
		local dy = (v.y - mo.y)
		-- artificially reduce distance with height so that the lower the bomb goes, the more height you gain and the less speed you gain.

		local dm = max(1, P_AproxDistance(P_AproxDistance(dx, dy), dz))
		local scale = mo.scale

		local force = mo.extravalue1 or BEAN_BOMBFORCE
		local waterdiv = v.eflags & MFE_UNDERWATER and 2 or 1

		v.momx = $+ FixedMul(scale, FixedMul(FixedDiv(dx, dm), force)) / waterdiv
		v.momy = $+ FixedMul(scale, FixedMul(FixedDiv(dy, dm), force)) / waterdiv

		--if not P_IsObjectOnGround(v)
			local momz = FixedMul(scale, FixedMul(FixedDiv(dz, max(1, dm)), force)) /2 / (waterdiv > 1 and 3 or 1)
			-- cap this so that it doesn't get out of hand.
			momz = min($, mo.scale*40)
			momz = max($, -mo.scale*40)

			v.momz = $+ momz
			-- keep z momentum in check, but be more lenient on distance.
			v.player.pflags = $ & ~PF_JUMPED
			v.state = S_PLAY_BEANLAUNCH
			v.bean_fire = TICRATE
			v.bean_bombjump = true
			v.bean_bombsthrown = $ or 1	-- Make sure this is never < 2, Bean shouldn't be able to triple bomb again after flinging himself.
		/*else
			-- send in sliding state
			P_InstaThrust(v, v.angle, v.scale*40)
			v.bean_slide = 1	-- 1 = no control
			v.state = S_PLAY_BEANSLIDE
			return
		end*/
		-- ^ slide remnants, uncommennt ground check and the above block to restore slide behaviour.

		local spd = tp.player.speed or 16*tp.scale
		-- default speed.

		local zdiff
		if mo.eflags & MFE_VERTICALFLIP
			if mo.z < tp.z
				zdiff = 0
			else
				zdiff = mo.z - tp.z
			end
		else
			if mo.z > tp.z
				zdiff = 0
			else
				zdiff = tp.z - mo.z
			end
		end

		-- let's be gentle, if the momentum is negative, make it positive anyway:
		if v.eflags & MFE_VERTICALFLIP
			if v.momz > -v.scale*5
				v.momz = -v.scale*5
			end

			if v.momz < -v.scale*24
				v.momz = -v.scale*24
			end

		else
			if v.momz < v.scale*5
				v.momz = v.scale*5
			end

			if v.momz > v.scale*24
				v.momz = v.scale*24
			end

		end

	elseif v.type == MT_SPIKE
	or v.type == MT_WALLSPIKE
		P_KillMobj(v, mo, mo.target)

	elseif v.flags & (MF_SHOOTABLE) or v.type == MT_METALSONIC_BATTLE
		P_DamageMobj(v, mo, mo.target)
	end
end

-- Uh, make it die, I guess !?
function A_BeanBombDeath(mo)

	S_StartSound(mo, sfx_bnboom)
	mo.fuse = 10
	mo.health = 0

	local range = 256*mo.scale
	searchBlockmap("objects", PIT_BombBlockmap, mo, mo.x-range, mo.x+range, mo.y-range, mo.y+range)

	-- spawn some visuals!
	for i = 1, 16
		local d = P_SpawnMobj(mo.x, mo.y, mo.z, mo.eflags & MFE_UNDERWATER and MT_UWEXPLODE or MT_TNTDUST)
		d.scale = mo.scale
		d.height = mo.height
		d.radius = mo.radius
		d.flags = $ & ~(MF_NOCLIPHEIGHT|MF_NOCLIP)	-- don't clip on floors
		d.eflags = mo.eflags & MFE_VERTICALFLIP

		if not (mo.eflags & MFE_UNDERWATER)
			-- move dust
			P_InstaThrust(d, P_RandomRange(1, 360)*ANG1, P_RandomRange(2, 8)*mo.scale)
		else
			-- have uw explosions look natural (?)
			P_TeleportMove(d, d.x + P_RandomRange(-96, 96)*mo.scale, d.y + P_RandomRange(-96, 96)*mo.scale, d.z + P_RandomRange(0, 96)*mo.scale)
		end

		d.momz = P_RandomRange(-8, 8)*mo.scale
		if d.eflags & MFE_UNDERWATER
			d.momz = abs($)*P_MobjFlip(d)
		end
	end

	local boom = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
	boom.state = S_BEAN_XP1
	if mo.eflags & MFE_UNDERWATER
		boom.state = mobjinfo[MT_UWEXPLODE].spawnstate
		boom.scale = $*2
	end

	-- big splash at water top
	local watercheck = mo.eflags & MFE_VERTICALFLIP and "waterbottom" or "watertop"
	--print((abs(mo[watercheck] - mo.z)).."|"..(192*mo.scale))

	if abs(mo[watercheck] - mo.z) < 192*mo.scale
		--print("A")
		-- more visuals. woo.
		local splash = P_SpawnMobj(mo.x, mo.y, mo[watercheck], MT_THOK)
		splash.state = S_SPLISH1
		splash.scale = mo.scale*6
		splash.eflags = mo.eflags & MFE_VERTICALFLIP

		splash = P_SpawnMobj(mo.x, mo.y, mo[watercheck], MT_THOK)
		splash.state = S_SPLISH1
		splash.scale = mo.scale*4
		splash.destscale = mo.scale*8
		splash.scalespeed = mo.scale/3
		splash.eflags = mo.eflags & MFE_VERTICALFLIP
	end

	-- bustable fof checks:

	for i = 1, 10	-- start by checking all around the bomb:
		local an = 360/8*ANG1*i
		local x = mo.x + FixedMul(mo.scale, 96*cos(an))
		local y = mo.y + FixedMul(mo.scale, 96*sin(an))

		if i > 8	-- 9 & 10: check top and bottom of bomb
			x = mo.x
			y = mo.y
		end

		local sec = R_PointInSubsector(x, y).sector
		local z = mo.z
		if i == 9
			z = mo.z + 96*mo.scale
		elseif i == 10
			z = mo.z - 96*mo.scale	-- a bit hacky
		end

		local zrange = 96*mo.scale

		-- iterate through rovers
		for rover in sec.ffloors() do

			if rover.flags & FF_EXISTS
			and rover.flags & FF_BUSTUP
				-- fof exists and is bustable
				if z + zrange > rover.bottomheight
				and z - zrange < rover.topheight
					EV_CrumbleChain(sec, rover)
				end
			end
		end
	end
end

-- fake bomb trajectory:
-- we will move along the object momx/momy (assuming it won't get deviated)
-- and fake gravity to spawn a reticle at the aproximate location of the bomb's landing.

local function fakeBombTrajectory(mo)
	local momx = mo.momx
	local momy = mo.momy
	local momz = mo.momz
	local i = 0

	local m = P_SpawnMobjFromMobj(mo, 0,0,0, MT_THOK)
	m.radius = mo.radius
	m.height = mo.height
	m.flags = MF_NOGRAVITY
	m.flags2 = $|MF2_DONTDRAW
	-- object we'll try moving.

	/*if not mo.target or not mo.target.valid
	or not mo.target.player or mo.target.player ~= consoleplayer
		return
	end*/	--!

	while m and m.valid and i < BEAN_MAXPREDICTTICS

		P_TeleportMove(m, m.x, m.y, m.z)
		-- update our position to make sure flags are good (?)

		if P_TryMove(m, m.x + momx, m.y + momy, true)
		and i < BEAN_MAXPREDICTTICS-1
			m.z = $ + momz

			-- check for underwater.
			-- yes it's a lot harder than it needs to be because MFE_UNDERWATER doesn't get updated.
			local s = mo.subsector.sector
			local water

			for rover in s.ffloors() do
				if rover.topheight > mo.z
				and rover.bottomheight < mo.z
				and rover.flags & FF_SWIMMABLE
					water = true
					--print("in water ("..i..")")
					break
				end
			end

			local mgravity = P_GetMobjGravity(m)
			-- reduce momz by 66% underwater
			if water
				mgravity = $/3	-- simplier than 58.5%? apparently it seems to be 33.3%
			end

			momz = $ + mgravity	-- fake gravity and momx/momy to predict trajectory

			-- uncomment the 3 lines below for debug thok step-by-step trajectory display
			--local g = P_SpawnGhostMobj(m)
			--g.tics = TICRATE
			--g.fuse = TICRATE

			if momz*P_MobjFlip(mo) < 0
				momz = $ + mgravity
			end
		else
			mo.tracer = P_SpawnMobjFromMobj(m , 0, 0, 0, MT_THOK)
			--print("return @ i = "..i)
			return	-- the rest is on you!
		end

		if P_IsObjectOnGround(m)
			mo.tracer = P_SpawnMobjFromMobj(m , 0, 0, 0, MT_THOK)	-- yes, here too.
			--print("return @ i = "..i)
			return	-- the rest is on you.
		end

		i = $+1
	end
end

states[S_BEANBOMB] = {SPR_BBOM, FF_ANIMATE, -1, nil, 1, 2, S_BEANBOMB}
states[S_BEANBOMBDEAD] = {SPR_NULL, 0, 8, A_BeanBombDeath, 0, 0, S_NULL}

-- Thinker for the bomb.
-- Essentially; kill it if it touches the floor.
-- MF_MISSILE takes care of its death on walls.

addHook("MobjThinker", function(mo)

	-- predict trajectory for client.
	if not mo.extravalue2
		fakeBombTrajectory(mo)	-- if we can explode land anywhere, this sets the spawned reticle as our tracer!
		mo.extravalue2 = 1
	end

	-- tracer? entertain our reticle!
	if mo.tracer and mo.tracer.valid
		mo.tracer.fuse = 20
		mo.tracer.tics = 2
		mo.tracer.sprite = SPR_TARG
		mo.tracer.frame = leveltime%14 / 2

		if leveltime & 1
			mo.tracer.flags2 = $ | MF2_DONTDRAW
		else
			mo.tracer.flags2 = $ & ~MF2_DONTDRAW
		end
	end

	mo.shadowscale = FRACUNIT*2/3

	if leveltime & 1
		local g = P_SpawnGhostMobj(mo)
		g.fuse = 3

		if mo.target and mo.target.valid	-- match thrower's colour~
			g.colorized = true
			g.color = mo.target.color
		end
		g.destscale = mo.scale*2

		local s = P_SpawnMobj(mo.x, mo.y, mo.z, mo.eflags & MFE_UNDERWATER and MT_MEDIUMBUBBLE or MT_SMOKE)
		s.destscale = mo.scale*2
	end

	if P_IsObjectOnGround(mo)
	and mo.health
	or mo.fuse == 1	-- auto-suicide.
		P_KillMobj(mo)
		return
	end

	-- heavier gravity when going down:
	if mo.momz*P_MobjFlip(mo) < 0
		mo.momz = $ + P_GetMobjGravity(mo)
	end

end, MT_BEANBOMB)