-- Who would've guessed! This is where most of the magic comes into play.
-- Kanade best waifu

local function bean_Inputs(p)
	local mo = p.mo
	mo.bean_usetimer = $ or 0
	mo.bean_jumptimer = $ or 0		-- don't count button holds, etc...
	mo.bean_bufjumptimer = $ or 0	-- this is a hack to not fuck up with normal jumping.

	-- CARRY BUFFER:
	-- Bean shouldn't be allowed to use his spin ability while carried (or in stasis)
	if mo.bean_carrybuf
		mo.bean_carrybuf = $-1
	end
	if p.powers[pw_carry]
		mo.bean_carrybuf = 2
	end

	if not mo.health
	or p.exiting
	or p.powers[pw_nocontrol]
	--or mo.bean_carrybuf
	or p.pflags & PF_STASIS
	or p.gotflag
		mo.bean_usetimer = 0
		mo.bean_jumptimer = 0		-- don't count button holds, etc...
		mo.bean_bufjumptimer = 0	-- this is a hack to not fuck up with normal jumping.


		return	-- bad!
	end

	if p.cmd.buttons & BT_USE
	--and not (p.pflags & PF_JUMPED and p.powers[pw_shield] and p.powers[pw_shield] != SH_PITY)
		mo.bean_usetimer = $+1
	else
		mo.bean_usetimer = 0
	end

	if p.cmd.buttons & BT_JUMP
	and not p.powers[pw_carry]	-- don't do that either.
		mo.bean_jumptimer = $+1
	else
		mo.bean_jumptimer = 0
	end


	-- detecing the jump press we want is a BIT more annoying because srb2 is GAY.
	mo.bean_bufjumptimer = $ or 0
	if p.pflags & PF_JUMPED
	and not p.powers[pw_carry]	-- STOP.
		mo.bean_bufjumptimer = $+1
	else
		mo.bean_bufjumptimer = 0
	end
	-- now we can start our bad checks
end

addHook("ShieldSpecial", function(p)

	local mo = p.mo
	if not mo or not mo.valid return end

	if mo.bean_throwbuf
	or mo.bean_bombsthrown and mo.bean_usetimer
		return true
	end
end)

-- This function handles throwing; inputs etc.
local function bean_ThrowBombHandle(p)
	local mo = p.mo

	-- Throwing has a few tics of delay.
	-- During that delay, pressing the other throw key will make you toss 2 bombs.
	bean_Inputs(p)
	mo.bean_bombsthrown = $ or 0	-- ready this just in case

	mo.bean_bombs = $ or {}
	-- check through that table to make sure there are no invalid bombs, if so, remove them.
	local i = #mo.bean_bombs
	while i
		if not mo.bean_bombs[i].valid
			table.remove(mo.bean_bombs, i)
		end
		i = $-1
	end


	if (mo.bean_usetimer == 1 or (mo.bean_jumptimer == 1 and (not mo.bean_bufjumptimer or mo.bean_bufjumptimer > 2) and not P_IsObjectOnGround(mo) ))
	and not p.powers[pw_carry]
	and not (p.pflags & PF_SLIDING)
	and not p.powers[pw_nocontrol]
	and not mo.bean_carrybuf

		if mo.bean_bombs and #mo.bean_bombs	-- we already have thrown bombs?

			if mo.bean_detonatecooldown
				return	-- chotto matte!
			end

			for i = 1, #mo.bean_bombs
				if mo.bean_bombs[i] and mo.bean_bombs[i].valid
				and mo.bean_bombs[i].health	-- not already detonated.
					P_KillMobj(mo.bean_bombs[i], mo, mo)
				end
			end

			-- detonate them all!
			return
		end

		if mo.bean_throwbuf
		or mo.bean_throwcooldown					-- cannot start buffering a throw in that case.
		or mo.bean_bombsthrown >= BEAN_MAXBOMBS		-- max # of bombs per jump
		or P_PlayerInPain(p)
			return
		end

		-- Ok technically NOW we can throw a bomb
		--print("Bomb throw buffer")
		mo.bean_bombsthrown = $+1
		mo.bean_throwbuf = 5
		mo.bean_throwcooldown = BEAN_THROWCOOLDOWN	-- I guess don't let him spawn too much?
		mo.bean_throwtype = 0	-- 0 = 1 bomb, 1 = 3 bombs
		mo.bean_detonatecooldown = TICRATE/3	-- delay before being able to detonate your bombs.
		mo.state = S_PLAY_BEANTHROW	-- throw anim

		-- this is set if you press both jump & spin during the 5 tics of buffering

		if not P_IsObjectOnGround(mo)	-- cancel some Z momentum if used mid-air
			mo.momz = 3*mo.scale * P_MobjFlip(mo)
		end
	end

	-- throw buffer, I guess we could have a frame here??
	if mo.bean_throwbuf
		mo.bean_throwbuf = $-1

		if p.cmd.buttons & (BT_JUMP|BT_USE) == (BT_JUMP|BT_USE)	-- both buttons at once! Wow!
		and mo.bean_bombsthrown <= 1	-- can only be done as the first throw!
			mo.bean_throwtype = 1
		end

		if not mo.bean_throwbuf

			-- this is where we spawn the bomb(s)
			if not mo.bean_throwtype	-- only 1 bomb
				-- throw a bomb in our direction, speed is arbitrary for now.

				local zpos = mo.z + mo.scale*32
				if mo.eflags & MFE_VERTICALFLIP
					zpos = mo.z + mo.height - mo.scale*32
				end
				-- yes, reverse gravity is annoying...

				local bomb = P_SpawnMobjFromMobj(mo, 0, 0, mo.scale*32, MT_BEANBOMB)
				bomb.target = mo	-- don't explode it on me wtf.
				bomb.fuse = BEAN_MAXPREDICTTICS
				if mo.eflags & MFE_VERTICALFLIP
					bomb.eflags = $|MFE_VERTICALFLIP
					bomb.flags2 = $|MF2_OBJECTFLIP	-- sigh
				end

				S_StartSound(bomb, sfx_bntoss)

				local spd = max(p.speed*90/100, 8*mo.scale)	-- 90% of curr speed

				P_InstaThrust(bomb, mo.angle, spd)

				local momz = (min(36*mo.scale, spd))
				momz = max(16*mo.scale, $)

				if not P_IsObjectOnGround(mo)
					momz = mo.momz
				end

				bomb.momz = momz/3 * P_MobjFlip(mo)

				if bomb.eflags & MFE_UNDERWATER
					bomb.momz = $/2
				end

				table.insert(mo.bean_bombs, bomb)	-- insert bomb into the table.
			else	-- all 3!
				--print("Throw triple bombs")

				local ang = mo.angle - ANG1*30
				local zpos = mo.z + mo.scale*32
				if mo.eflags & MFE_VERTICALFLIP
					zpos = mo.z + mo.height - mo.scale*32
				end
				-- yes, reverse gravity is annoying...

				for i = 1, 3
					local bomb = P_SpawnMobjFromMobj(mo, 0, 0, mo.scale*32, MT_BEANBOMB)
					bomb.target = mo	-- don't explode it on me wtf.
					bomb.fuse = BEAN_MAXPREDICTTICS
					if mo.eflags & MFE_VERTICALFLIP
						bomb.eflags = $|MFE_VERTICALFLIP
						bomb.flags2 = $|MF2_OBJECTFLIP	-- sigh
					end

					S_StartSound(bomb, sfx_bntoss)

					local spd = max(p.speed*9/10, 8*mo.scale)

					local angle = ang + P_RandomRange(-15, 15)*ANG1	-- lol!
					local zoff = P_RandomRange(0, 5)*mo.scale

					P_InstaThrust(bomb, ang, spd/3)
					bomb.momz = ((min(48*mo.scale, spd))/7 + zoff)/2 * P_MobjFlip(mo)
					bomb.extravalue1 = BEAN_BOMBFORCE*2/3	-- override force value.

					if bomb.eflags & MFE_UNDERWATER
						bomb.momz = $/2
					end

					ang = $ + ANG1*30

					table.insert(mo.bean_bombs, bomb)	-- insert bomb into the table.
				end

				mo.momx = $/2
				mo.momy = $/2
			end
		end
	end



	if mo.bean_throwcooldown
		mo.bean_throwcooldown = $-1
	end

	if mo.bean_detonatecooldown
		mo.bean_detonatecooldown = $-1
	end

	if P_IsObjectOnGround(mo)
	or p.powers[pw_carry]
		mo.bean_bombsthrown = 0
	end
end

-- visuals for bomb jumping + z mom keep + launch state
local function bean_BombJumpHandle(p)

	local mo = p.mo
	if mo.bean_bombjump
		p.pflags = $|PF_JUMPDOWN	-- keep zmom

		if leveltime % 2 == 0
			local d = P_SpawnMobj(mo.x + P_RandomRange(-16, 16)*mo.scale, mo.y + P_RandomRange(-16, 16)*mo.scale, mo.z + P_RandomRange(-32, 16)*mo.scale, mo.eflags & MFE_UNDERWATER and MT_MEDIUMBUBBLE or MT_SMOKE)
			d.scale = mo.scale
			d.destscale = mo.scale*2
		end

		if mo.bean_fire

			local d = P_SpawnMobj(mo.x + P_RandomRange(-16, 16)*mo.scale, mo.y + P_RandomRange(-16, 16)*mo.scale, mo.z + P_RandomRange(-32, 16)*mo.scale, mo.eflags & MFE_UNDERWATER and MT_MEDIUMBUBBLE or MT_THOK)
			if not (mo.eflags & MFE_UNDERWATER)
				d.sprite = SPR_FPRT
				d.eflags = mo.eflags & MFE_VERTICALFLIP
				if mo.eflags & MFE_VERTICALFLIP
					d.z = $-mo.height/2
				end
				d.frame = A|FF_FULLBRIGHT|TR_TRANS20
				d.scale = mo.scale
				d.destscale = mo.scale*10
				d.momx = mo.momx/2
				d.momy = mo.momy/2
				d.momz = mo.momz/2
				d.scalespeed = mo.scale/4
			end
			mo.bean_fire = $-1
		end

		if P_IsObjectOnGround(mo)
		or p.powers[pw_carry]
			mo.bean_bombjump = nil
		end
	end

	-- fall state after launch
	if mo.state == S_PLAY_BEANLAUNCH
	and mo.momz*P_MobjFlip(mo) < 0
		mo.state = S_PLAY_FALL
	end

end

local function bean_cancelSlide(p, dostate)
	local mo = p.mo

	mo.bean_slide = 0
	mo.bean_prevz = nil	-- avoid acceleration bursts on new slides by not keeping this.
	p.powers[pw_nocontrol] = 0
	p.pflags = $ & ~PF_SLIDING
	if dostate
		mo.state = P_IsObjectOnGround(mo) and S_PLAY_STND or S_PLAY_FALL
	end
end

local function bean_SlideHandle(p)
	local mo = p.mo

	if mo.bean_slide

		--print(mo.height/mo.scale)

		mo.height = 16*mo.scale
		p.pflags = $|PF_SLIDING
		mo.sprite2 = SPR2_SLID
		mo.frame = A	-- I shit you not.

		if leveltime % 5 == 0
			local d = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SMOKE)
			d.scale = mo.scale
			d.destscale = mo.scale*2
		end
		P_SpawnSkidDust(p, mo.radius, true)

		p.powers[pw_nocontrol] = (mo.bean_slide == 1) and 1 or 0

		if p.cmd.buttons & BT_JUMP
		and P_IsObjectOnGround(mo)
			bean_cancelSlide(p, false)
			if abs(mo.ceilingz - mo.floorz) < P_GetPlayerHeight(p)	-- spin
				mo.state = S_PLAY_ROLL
				p.panim = PA_ROLL
				p.pflags = $ & ~PF_NOJUMPDAMAGE
				p.pflags = $|PF_SPINNING
				return
			else
				P_DoJump(p)
				mo.state = S_PLAY_ROLL
				p.panim = PA_ROLL
				p.pflags = $ & ~PF_NOJUMPDAMAGE
				return
			end
		end

		-- thrust while going down slopes ig
		if mo.bean_prevz ~= nil
			if mo.standingslope

				local thrust = mo.bean_prevz - mo.z
				local ang = R_PointToAngle2(0, 0, mo.momx, mo.momy)
				-- @todo: use slope.xydirection maybe one day? it has issues however.

				if thrust < 0	-- be lenient with upslopes
					thrust = $/64
				end

				P_Thrust(mo, ang, min(16*mo.scale, thrust/2))
			end
		end
		mo.bean_prevz = mo.z

		if R_PointToDist2(0, 0, mo.momx, mo.momy) < mo.scale*2
		-- check space between ceiling and floor
			if abs(mo.ceilingz - mo.floorz) < P_GetPlayerHeight(p)	-- yikes.
				P_InstaThrust(mo, mo.angle, FRACUNIT*8)
				mo.bean_slide = 2
			else
				bean_cancelSlide(p, true)
			end
		end

		if not P_IsObjectOnGround(mo)
			-- don't set the state to fall if the player has jumped out intentionally.
			bean_cancelSlide(p, not ((p.pflags & PF_JUMPED) or mo.eflags & MFE_SPRUNG))
		end
	end
end

addHook("PlayerThink", function(p)
	-- this hook literally only exists because player height is stupid
	local mo = p.mo
	if not mo return end

	if mo.bean_slide
		mo.height = 16*mo.scale
		mo.state = S_PLAY_BEANSLIDE
		p.pflags = $|PF_SLIDING
	end

end, "bean")

-- various things that undo slide...
addHook("MobjDamage", function(mo)
	if mo and mo.valid and mo.player and mo.player.valid and mo.skin == "bean"
		if mo.bean_slide
			bean_cancelSlide(mo.player, false)
		end
	end
end, MT_PLAYER)

addHook("MapLoad", do
	for p in players.iterate do
		-- game can potentially be retarded:
		p.powers[pw_nocontrol] = 0
	end
end)

local function bean_IdleHandle(p)

	-- kind of a hack but who cares.
	local mo = p.mo

	if mo.state == S_PLAY_WAIT
	and mo.frame & B

		-- check for camera draw angle.
		-- we use this to know if we should offset the sprite in front of or behind the player
		local cang = R_PointToAngle(mo.x, mo.y)
		local ang = cang - (p.drawangle)
		local rot = ((ang+ANGLE_202h)>>29) +1
		-- res: 1-8

		local offs = {
			1,		-- A1: behind
			1,		-- A2: behind
			-1,		-- A3: front
			-1,		-- A4: front
			-1,		-- A5: front
			1,		-- A6: behind
			1,		-- A7: behind
			1,		-- A8: behind
		}

		-- spawn the fake bomb:
		local amplitude = 35
		local ang_per_tic = ANGLE_11hh
		local duration = 16
		local z = 12*mo.scale + FixedMul(mo.scale, amplitude*sin( (duration-mo.anim_duration)*ang_per_tic))
		local x = FixedMul(mo.scale, 2*cos(cang)*offs[rot])
		local y = FixedMul(mo.scale, 2*sin(cang)*offs[rot])

		local fakebomb = P_SpawnMobjFromMobj(mo, x, y, z, MT_THOK)

		fakebomb.tics = 1
		fakebomb.sprite = SPR_WBMB
		fakebomb.frame = A
		fakebomb.angle = mo.angle
		if mo.eflags & MFE_VERTICALFLIP
			fakebomb.eflags = $|MFE_VERTICALFLIP
		end
	end
end

-- No shield ability for bean. Fuck you.
addHook("ShieldSpecial", function(p)
	if p.mo and p.mo.valid and p.mo.skin == "bean"
		return true
	end
end)

-- Replace Whirlwind by Pity, this will make things easier because of Whirlwind 's weird jump while falling ability
local function bean_shieldOverride(p)
	if p.powers[pw_shield] == SH_WHIRLWIND
		p.powers[pw_shield] = SH_PITY
		P_SpawnShieldOrb(p)	-- reset the shield visual
	end
end

-- Mash all the functions into one.
addHook("ThinkFrame", do
	for p in players.iterate do
		if not p.mo or not p.mo.valid continue end
		if p.mo.skin ~= "bean" continue end

		bean_ThrowBombHandle(p)
		bean_BombJumpHandle(p)
		bean_SlideHandle(p)
		bean_IdleHandle(p)
		bean_shieldOverride(p)
	end
end)